// Package adw was automatically generated by github.com/jwijenbergh/puregotk DO NOT EDIT
package adw

import (
	"unsafe"

	"github.com/jwijenbergh/purego"
	"github.com/jwijenbergh/puregotk/internal/core"
	"github.com/jwijenbergh/puregotk/v4/gobject"
	"github.com/jwijenbergh/puregotk/v4/gtk"
)

type ViewSwitcherClass struct {
	ParentClass uintptr
}

func (x *ViewSwitcherClass) GoPointer() uintptr {
	return uintptr(unsafe.Pointer(x))
}

// Describes the adaptive modes of [class@ViewSwitcher].
type ViewSwitcherPolicy int

const (

	// Force the narrow mode
	ViewSwitcherPolicyNarrowValue ViewSwitcherPolicy = 0
	// Force the wide mode
	ViewSwitcherPolicyWideValue ViewSwitcherPolicy = 1
)

// An adaptive view switcher.
//
// &lt;picture&gt;
//
//	&lt;source srcset="view-switcher-dark.png" media="(prefers-color-scheme: dark)"&gt;
//	&lt;img src="view-switcher.png" alt="view-switcher"&gt;
//
// &lt;/picture&gt;
//
// An adaptive view switcher designed to switch between multiple views
// contained in a [class@ViewStack] in a similar fashion to
// [class@Gtk.StackSwitcher].
//
// `AdwViewSwitcher` buttons always have an icon and a label. They can be
// displayed side by side, or icon on top of the label. This can be controlled
// via the [property@ViewSwitcher:policy] property.
//
// Most applications should be using [class@ViewSwitcherBar] and
// [class@ViewSwitcherTitle].
//
// ## CSS nodes
//
// `AdwViewSwitcher` has a single CSS node with name `viewswitcher`. It can have
// the style classes `.wide` and `.narrow`, matching its policy.
//
// ## Accessibility
//
// `AdwViewSwitcher` uses the `GTK_ACCESSIBLE_ROLE_TAB_LIST` role and uses the
// `GTK_ACCESSIBLE_ROLE_TAB` for its buttons.
type ViewSwitcher struct {
	gtk.Widget
}

func ViewSwitcherNewFromInternalPtr(ptr uintptr) *ViewSwitcher {
	cls := &ViewSwitcher{}
	cls.Ptr = ptr
	return cls
}

var xNewViewSwitcher func() uintptr

// Creates a new `AdwViewSwitcher`.
func NewViewSwitcher() *ViewSwitcher {
	var cls *ViewSwitcher

	cret := xNewViewSwitcher()

	if cret == 0 {
		return nil
	}
	gobject.IncreaseRef(cret)
	cls = &ViewSwitcher{}
	cls.Ptr = cret
	return cls
}

var xViewSwitcherGetPolicy func(uintptr) ViewSwitcherPolicy

// Gets the policy of @self.
func (x *ViewSwitcher) GetPolicy() ViewSwitcherPolicy {

	cret := xViewSwitcherGetPolicy(x.GoPointer())
	return cret
}

var xViewSwitcherGetStack func(uintptr) uintptr

// Gets the stack controlled by @self.
func (x *ViewSwitcher) GetStack() *ViewStack {
	var cls *ViewStack

	cret := xViewSwitcherGetStack(x.GoPointer())

	if cret == 0 {
		return nil
	}
	gobject.IncreaseRef(cret)
	cls = &ViewStack{}
	cls.Ptr = cret
	return cls
}

var xViewSwitcherSetPolicy func(uintptr, ViewSwitcherPolicy)

// Sets the policy of @self.
func (x *ViewSwitcher) SetPolicy(PolicyVar ViewSwitcherPolicy) {

	xViewSwitcherSetPolicy(x.GoPointer(), PolicyVar)

}

var xViewSwitcherSetStack func(uintptr, uintptr)

// Sets the stack controlled by @self.
func (x *ViewSwitcher) SetStack(StackVar *ViewStack) {

	xViewSwitcherSetStack(x.GoPointer(), StackVar.GoPointer())

}

func (c *ViewSwitcher) GoPointer() uintptr {
	return c.Ptr
}

func (c *ViewSwitcher) SetGoPointer(ptr uintptr) {
	c.Ptr = ptr
}

// Retrieves the `GtkAccessibleRole` for the given `GtkAccessible`.
func (x *ViewSwitcher) GetAccessibleRole() gtk.AccessibleRole {

	cret := gtk.XGtkAccessibleGetAccessibleRole(x.GoPointer())
	return cret
}

// Resets the accessible @property to its default value.
func (x *ViewSwitcher) ResetProperty(PropertyVar gtk.AccessibleProperty) {

	gtk.XGtkAccessibleResetProperty(x.GoPointer(), PropertyVar)

}

// Resets the accessible @relation to its default value.
func (x *ViewSwitcher) ResetRelation(RelationVar gtk.AccessibleRelation) {

	gtk.XGtkAccessibleResetRelation(x.GoPointer(), RelationVar)

}

// Resets the accessible @state to its default value.
func (x *ViewSwitcher) ResetState(StateVar gtk.AccessibleState) {

	gtk.XGtkAccessibleResetState(x.GoPointer(), StateVar)

}

// Updates a list of accessible properties.
//
// See the [enum@Gtk.AccessibleProperty] documentation for the
// value types of accessible properties.
//
// This function should be called by `GtkWidget` types whenever
// an accessible property change must be communicated to assistive
// technologies.
//
// Example:
// ```c
// value = gtk_adjustment_get_value (adjustment);
// gtk_accessible_update_property (GTK_ACCESSIBLE (spin_button),
//
//	GTK_ACCESSIBLE_PROPERTY_VALUE_NOW, value,
//	-1);
//
// ```
func (x *ViewSwitcher) UpdateProperty(FirstPropertyVar gtk.AccessibleProperty, varArgs ...interface{}) {

	gtk.XGtkAccessibleUpdateProperty(x.GoPointer(), FirstPropertyVar, varArgs...)

}

// Updates an array of accessible properties.
//
// This function should be called by `GtkWidget` types whenever an accessible
// property change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *ViewSwitcher) UpdatePropertyValue(NPropertiesVar int, PropertiesVar uintptr, ValuesVar uintptr) {

	gtk.XGtkAccessibleUpdatePropertyValue(x.GoPointer(), NPropertiesVar, PropertiesVar, ValuesVar)

}

// Updates a list of accessible relations.
//
// This function should be called by `GtkWidget` types whenever an accessible
// relation change must be communicated to assistive technologies.
//
// If the [enum@Gtk.AccessibleRelation] requires a list of references,
// you should pass each reference individually, followed by %NULL, e.g.
//
// ```c
// gtk_accessible_update_relation (accessible,
//
//	GTK_ACCESSIBLE_RELATION_CONTROLS,
//	  ref1, NULL,
//	GTK_ACCESSIBLE_RELATION_LABELLED_BY,
//	  ref1, ref2, ref3, NULL,
//	-1);
//
// ```
func (x *ViewSwitcher) UpdateRelation(FirstRelationVar gtk.AccessibleRelation, varArgs ...interface{}) {

	gtk.XGtkAccessibleUpdateRelation(x.GoPointer(), FirstRelationVar, varArgs...)

}

// Updates an array of accessible relations.
//
// This function should be called by `GtkWidget` types whenever an accessible
// relation change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *ViewSwitcher) UpdateRelationValue(NRelationsVar int, RelationsVar uintptr, ValuesVar uintptr) {

	gtk.XGtkAccessibleUpdateRelationValue(x.GoPointer(), NRelationsVar, RelationsVar, ValuesVar)

}

// Updates a list of accessible states. See the [enum@Gtk.AccessibleState]
// documentation for the value types of accessible states.
//
// This function should be called by `GtkWidget` types whenever an accessible
// state change must be communicated to assistive technologies.
//
// Example:
// ```c
// value = GTK_ACCESSIBLE_TRISTATE_MIXED;
// gtk_accessible_update_state (GTK_ACCESSIBLE (check_button),
//
//	GTK_ACCESSIBLE_STATE_CHECKED, value,
//	-1);
//
// ```
func (x *ViewSwitcher) UpdateState(FirstStateVar gtk.AccessibleState, varArgs ...interface{}) {

	gtk.XGtkAccessibleUpdateState(x.GoPointer(), FirstStateVar, varArgs...)

}

// Updates an array of accessible states.
//
// This function should be called by `GtkWidget` types whenever an accessible
// state change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *ViewSwitcher) UpdateStateValue(NStatesVar int, StatesVar uintptr, ValuesVar uintptr) {

	gtk.XGtkAccessibleUpdateStateValue(x.GoPointer(), NStatesVar, StatesVar, ValuesVar)

}

// Gets the ID of the @buildable object.
//
// `GtkBuilder` sets the name based on the ID attribute
// of the &lt;object&gt; tag used to construct the @buildable.
func (x *ViewSwitcher) GetBuildableId() string {

	cret := gtk.XGtkBuildableGetBuildableId(x.GoPointer())
	return cret
}

func init() {
	lib, err := purego.Dlopen(core.GetPath("ADW"), purego.RTLD_NOW|purego.RTLD_GLOBAL)
	if err != nil {
		panic(err)
	}

	core.PuregoSafeRegister(&xNewViewSwitcher, lib, "adw_view_switcher_new")

	core.PuregoSafeRegister(&xViewSwitcherGetPolicy, lib, "adw_view_switcher_get_policy")
	core.PuregoSafeRegister(&xViewSwitcherGetStack, lib, "adw_view_switcher_get_stack")
	core.PuregoSafeRegister(&xViewSwitcherSetPolicy, lib, "adw_view_switcher_set_policy")
	core.PuregoSafeRegister(&xViewSwitcherSetStack, lib, "adw_view_switcher_set_stack")

}
