// Package adw was automatically generated by github.com/jwijenbergh/puregotk DO NOT EDIT
package adw

import (
	"unsafe"

	"github.com/jwijenbergh/purego"
	"github.com/jwijenbergh/puregotk/internal/core"
	"github.com/jwijenbergh/puregotk/v4/gobject"
	"github.com/jwijenbergh/puregotk/v4/gtk"
)

type WindowTitleClass struct {
	ParentClass uintptr
}

func (x *WindowTitleClass) GoPointer() uintptr {
	return uintptr(unsafe.Pointer(x))
}

// A helper widget for setting a window's title and subtitle.
//
// &lt;picture&gt;
//
//	&lt;source srcset="window-title-dark.png" media="(prefers-color-scheme: dark)"&gt;
//	&lt;img src="window-title.png" alt="window-title"&gt;
//
// &lt;/picture&gt;
//
// `AdwWindowTitle` shows a title and subtitle. It's intended to be used as the
// title child of [class@Gtk.HeaderBar] or [class@HeaderBar].
//
// ## CSS nodes
//
// `AdwWindowTitle` has a single CSS node with name `windowtitle`.
type WindowTitle struct {
	gtk.Widget
}

func WindowTitleNewFromInternalPtr(ptr uintptr) *WindowTitle {
	cls := &WindowTitle{}
	cls.Ptr = ptr
	return cls
}

var xNewWindowTitle func(string, string) uintptr

// Creates a new `AdwWindowTitle`.
func NewWindowTitle(TitleVar string, SubtitleVar string) *WindowTitle {
	var cls *WindowTitle

	cret := xNewWindowTitle(TitleVar, SubtitleVar)

	if cret == 0 {
		return nil
	}
	gobject.IncreaseRef(cret)
	cls = &WindowTitle{}
	cls.Ptr = cret
	return cls
}

var xWindowTitleGetSubtitle func(uintptr) string

// Gets the subtitle of @self.
func (x *WindowTitle) GetSubtitle() string {

	cret := xWindowTitleGetSubtitle(x.GoPointer())
	return cret
}

var xWindowTitleGetTitle func(uintptr) string

// Gets the title of @self.
func (x *WindowTitle) GetTitle() string {

	cret := xWindowTitleGetTitle(x.GoPointer())
	return cret
}

var xWindowTitleSetSubtitle func(uintptr, string)

// Sets the subtitle of @self.
//
// The subtitle should give the user additional details.
func (x *WindowTitle) SetSubtitle(SubtitleVar string) {

	xWindowTitleSetSubtitle(x.GoPointer(), SubtitleVar)

}

var xWindowTitleSetTitle func(uintptr, string)

// Sets the title of @self.
//
// The title typically identifies the current view or content item, and
// generally does not use the application name.
func (x *WindowTitle) SetTitle(TitleVar string) {

	xWindowTitleSetTitle(x.GoPointer(), TitleVar)

}

func (c *WindowTitle) GoPointer() uintptr {
	return c.Ptr
}

func (c *WindowTitle) SetGoPointer(ptr uintptr) {
	c.Ptr = ptr
}

// Retrieves the `GtkAccessibleRole` for the given `GtkAccessible`.
func (x *WindowTitle) GetAccessibleRole() gtk.AccessibleRole {

	cret := gtk.XGtkAccessibleGetAccessibleRole(x.GoPointer())
	return cret
}

// Resets the accessible @property to its default value.
func (x *WindowTitle) ResetProperty(PropertyVar gtk.AccessibleProperty) {

	gtk.XGtkAccessibleResetProperty(x.GoPointer(), PropertyVar)

}

// Resets the accessible @relation to its default value.
func (x *WindowTitle) ResetRelation(RelationVar gtk.AccessibleRelation) {

	gtk.XGtkAccessibleResetRelation(x.GoPointer(), RelationVar)

}

// Resets the accessible @state to its default value.
func (x *WindowTitle) ResetState(StateVar gtk.AccessibleState) {

	gtk.XGtkAccessibleResetState(x.GoPointer(), StateVar)

}

// Updates a list of accessible properties.
//
// See the [enum@Gtk.AccessibleProperty] documentation for the
// value types of accessible properties.
//
// This function should be called by `GtkWidget` types whenever
// an accessible property change must be communicated to assistive
// technologies.
//
// Example:
// ```c
// value = gtk_adjustment_get_value (adjustment);
// gtk_accessible_update_property (GTK_ACCESSIBLE (spin_button),
//
//	GTK_ACCESSIBLE_PROPERTY_VALUE_NOW, value,
//	-1);
//
// ```
func (x *WindowTitle) UpdateProperty(FirstPropertyVar gtk.AccessibleProperty, varArgs ...interface{}) {

	gtk.XGtkAccessibleUpdateProperty(x.GoPointer(), FirstPropertyVar, varArgs...)

}

// Updates an array of accessible properties.
//
// This function should be called by `GtkWidget` types whenever an accessible
// property change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *WindowTitle) UpdatePropertyValue(NPropertiesVar int, PropertiesVar uintptr, ValuesVar uintptr) {

	gtk.XGtkAccessibleUpdatePropertyValue(x.GoPointer(), NPropertiesVar, PropertiesVar, ValuesVar)

}

// Updates a list of accessible relations.
//
// This function should be called by `GtkWidget` types whenever an accessible
// relation change must be communicated to assistive technologies.
//
// If the [enum@Gtk.AccessibleRelation] requires a list of references,
// you should pass each reference individually, followed by %NULL, e.g.
//
// ```c
// gtk_accessible_update_relation (accessible,
//
//	GTK_ACCESSIBLE_RELATION_CONTROLS,
//	  ref1, NULL,
//	GTK_ACCESSIBLE_RELATION_LABELLED_BY,
//	  ref1, ref2, ref3, NULL,
//	-1);
//
// ```
func (x *WindowTitle) UpdateRelation(FirstRelationVar gtk.AccessibleRelation, varArgs ...interface{}) {

	gtk.XGtkAccessibleUpdateRelation(x.GoPointer(), FirstRelationVar, varArgs...)

}

// Updates an array of accessible relations.
//
// This function should be called by `GtkWidget` types whenever an accessible
// relation change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *WindowTitle) UpdateRelationValue(NRelationsVar int, RelationsVar uintptr, ValuesVar uintptr) {

	gtk.XGtkAccessibleUpdateRelationValue(x.GoPointer(), NRelationsVar, RelationsVar, ValuesVar)

}

// Updates a list of accessible states. See the [enum@Gtk.AccessibleState]
// documentation for the value types of accessible states.
//
// This function should be called by `GtkWidget` types whenever an accessible
// state change must be communicated to assistive technologies.
//
// Example:
// ```c
// value = GTK_ACCESSIBLE_TRISTATE_MIXED;
// gtk_accessible_update_state (GTK_ACCESSIBLE (check_button),
//
//	GTK_ACCESSIBLE_STATE_CHECKED, value,
//	-1);
//
// ```
func (x *WindowTitle) UpdateState(FirstStateVar gtk.AccessibleState, varArgs ...interface{}) {

	gtk.XGtkAccessibleUpdateState(x.GoPointer(), FirstStateVar, varArgs...)

}

// Updates an array of accessible states.
//
// This function should be called by `GtkWidget` types whenever an accessible
// state change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *WindowTitle) UpdateStateValue(NStatesVar int, StatesVar uintptr, ValuesVar uintptr) {

	gtk.XGtkAccessibleUpdateStateValue(x.GoPointer(), NStatesVar, StatesVar, ValuesVar)

}

// Gets the ID of the @buildable object.
//
// `GtkBuilder` sets the name based on the ID attribute
// of the &lt;object&gt; tag used to construct the @buildable.
func (x *WindowTitle) GetBuildableId() string {

	cret := gtk.XGtkBuildableGetBuildableId(x.GoPointer())
	return cret
}

func init() {
	lib, err := purego.Dlopen(core.GetPath("ADW"), purego.RTLD_NOW|purego.RTLD_GLOBAL)
	if err != nil {
		panic(err)
	}

	core.PuregoSafeRegister(&xNewWindowTitle, lib, "adw_window_title_new")

	core.PuregoSafeRegister(&xWindowTitleGetSubtitle, lib, "adw_window_title_get_subtitle")
	core.PuregoSafeRegister(&xWindowTitleGetTitle, lib, "adw_window_title_get_title")
	core.PuregoSafeRegister(&xWindowTitleSetSubtitle, lib, "adw_window_title_set_subtitle")
	core.PuregoSafeRegister(&xWindowTitleSetTitle, lib, "adw_window_title_set_title")

}
