// Package gtk was automatically generated by github.com/jwijenbergh/puregotk DO NOT EDIT
package gtk

import (
	"github.com/jwijenbergh/purego"
	"github.com/jwijenbergh/puregotk/internal/core"
	"github.com/jwijenbergh/puregotk/v4/gobject"
)

// Renders a spinning animation in a cell
//
// `GtkCellRendererSpinner` renders a spinning animation in a cell, very
// similar to `GtkSpinner`. It can often be used as an alternative
// to a `GtkCellRendererProgress` for displaying indefinite activity,
// instead of actual progress.
//
// To start the animation in a cell, set the `GtkCellRendererSpinner:active`
// property to %TRUE and increment the `GtkCellRendererSpinner:pulse` property
// at regular intervals. The usual way to set the cell renderer properties
// for each cell is to bind them to columns in your tree model using e.g.
// gtk_tree_view_column_add_attribute().
type CellRendererSpinner struct {
	CellRenderer
}

func CellRendererSpinnerNewFromInternalPtr(ptr uintptr) *CellRendererSpinner {
	cls := &CellRendererSpinner{}
	cls.Ptr = ptr
	return cls
}

var xNewCellRendererSpinner func() uintptr

// Returns a new cell renderer which will show a spinner to indicate
// activity.
func NewCellRendererSpinner() *CellRendererSpinner {
	var cls *CellRendererSpinner

	cret := xNewCellRendererSpinner()

	if cret == 0 {
		return nil
	}
	gobject.IncreaseRef(cret)
	cls = &CellRendererSpinner{}
	cls.Ptr = cret
	return cls
}

func (c *CellRendererSpinner) GoPointer() uintptr {
	return c.Ptr
}

func (c *CellRendererSpinner) SetGoPointer(ptr uintptr) {
	c.Ptr = ptr
}

func init() {
	lib, err := purego.Dlopen(core.GetPath("GTK"), purego.RTLD_NOW|purego.RTLD_GLOBAL)
	if err != nil {
		panic(err)
	}

	core.PuregoSafeRegister(&xNewCellRendererSpinner, lib, "gtk_cell_renderer_spinner_new")

}
