// Package gtk was automatically generated by github.com/jwijenbergh/puregotk DO NOT EDIT
package gtk

import (
	"github.com/jwijenbergh/purego"
	"github.com/jwijenbergh/puregotk/internal/core"
)

// Flags to use with gtk_set_debug_flags().
//
// Settings these flags causes GTK to print out different
// types of debugging information. Some of these flags are
// only available when GTK has been configured with `-Ddebug=true`.
type DebugFlags int

const (

	// Information about GtkTextView
	DebugTextValue DebugFlags = 1
	// Information about GtkTreeView
	DebugTreeValue DebugFlags = 2
	// Information about keyboard shortcuts
	DebugKeybindingsValue DebugFlags = 4
	// Information about modules and extensions
	DebugModulesValue DebugFlags = 8
	// Information about size allocation
	DebugGeometryValue DebugFlags = 16
	// Information about icon themes
	DebugIconthemeValue DebugFlags = 32
	// Information about printing
	DebugPrintingValue DebugFlags = 64
	// Trace GtkBuilder operation
	DebugBuilderValue DebugFlags = 128
	// Information about size requests
	DebugSizeRequestValue DebugFlags = 256
	// Disable the style property cache
	DebugNoCssCacheValue DebugFlags = 512
	// Open the GTK inspector
	DebugInteractiveValue DebugFlags = 1024
	// Pretend the pointer is a touchscreen
	DebugTouchscreenValue DebugFlags = 2048
	// Information about actions and menu models
	DebugActionsValue DebugFlags = 4096
	// Information from layout managers
	DebugLayoutValue DebugFlags = 8192
	// Include debug render nodes in the generated snapshots
	DebugSnapshotValue DebugFlags = 16384
	// Information from the constraints solver
	DebugConstraintsValue DebugFlags = 32768
	// Log unused GtkBuilder objects
	DebugBuilderObjectsValue DebugFlags = 65536
	// Information about accessibility state changes
	DebugA11yValue DebugFlags = 131072
	// Information about icon fallback. Since: 4.2
	DebugIconfallbackValue DebugFlags = 262144

	DebugInvertTextDirValue DebugFlags = 524288
)

var xGetDebugFlags func() DebugFlags

// Returns the GTK debug flags that are currently active.
//
// This function is intended for GTK modules that want
// to adjust their debug output based on GTK debug flags.
func GetDebugFlags() DebugFlags {

	cret := xGetDebugFlags()
	return cret
}

var xSetDebugFlags func(DebugFlags)

// Sets the GTK debug flags.
func SetDebugFlags(FlagsVar DebugFlags) {

	xSetDebugFlags(FlagsVar)

}

func init() {
	lib, err := purego.Dlopen(core.GetPath("GTK"), purego.RTLD_NOW|purego.RTLD_GLOBAL)
	if err != nil {
		panic(err)
	}
	core.PuregoSafeRegister(&xGetDebugFlags, lib, "gtk_get_debug_flags")
	core.PuregoSafeRegister(&xSetDebugFlags, lib, "gtk_set_debug_flags")

}
