// Package gtk was automatically generated by github.com/jwijenbergh/puregotk DO NOT EDIT
package gtk

import (
	"unsafe"

	"github.com/jwijenbergh/purego"
	"github.com/jwijenbergh/puregotk/internal/core"
)

type PrintOperationPreviewIface struct {
	GIface uintptr
}

func (x *PrintOperationPreviewIface) GoPointer() uintptr {
	return uintptr(unsafe.Pointer(x))
}

// `GtkPrintOperationPreview` is the interface that is used to
// implement print preview.
//
// A `GtkPrintOperationPreview` object is passed to the
// [signal@Gtk.PrintOperation::preview] signal by
// [class@Gtk.PrintOperation].
type PrintOperationPreview interface {
	GoPointer() uintptr
	SetGoPointer(uintptr)
	EndPreview()
	IsSelected(PageNrVar int) bool
	RenderPage(PageNrVar int)
}
type PrintOperationPreviewBase struct {
	Ptr uintptr
}

func (x *PrintOperationPreviewBase) GoPointer() uintptr {
	return x.Ptr
}

func (x *PrintOperationPreviewBase) SetGoPointer(ptr uintptr) {
	x.Ptr = ptr
}

// Ends a preview.
//
// This function must be called to finish a custom print preview.
func (x *PrintOperationPreviewBase) EndPreview() {

	XGtkPrintOperationPreviewEndPreview(x.GoPointer())

}

// Returns whether the given page is included in the set of pages that
// have been selected for printing.
func (x *PrintOperationPreviewBase) IsSelected(PageNrVar int) bool {

	cret := XGtkPrintOperationPreviewIsSelected(x.GoPointer(), PageNrVar)
	return cret
}

// Renders a page to the preview.
//
// This is using the print context that was passed to the
// [signal@Gtk.PrintOperation::preview] handler together
// with @preview.
//
// A custom print preview should use this function to render
// the currently selected page.
//
// Note that this function requires a suitable cairo context to
// be associated with the print context.
func (x *PrintOperationPreviewBase) RenderPage(PageNrVar int) {

	XGtkPrintOperationPreviewRenderPage(x.GoPointer(), PageNrVar)

}

var XGtkPrintOperationPreviewEndPreview func(uintptr)
var XGtkPrintOperationPreviewIsSelected func(uintptr, int) bool
var XGtkPrintOperationPreviewRenderPage func(uintptr, int)

func init() {
	lib, err := purego.Dlopen(core.GetPath("GTK"), purego.RTLD_NOW|purego.RTLD_GLOBAL)
	if err != nil {
		panic(err)
	}

	core.PuregoSafeRegister(&XGtkPrintOperationPreviewEndPreview, lib, "gtk_print_operation_preview_end_preview")
	core.PuregoSafeRegister(&XGtkPrintOperationPreviewIsSelected, lib, "gtk_print_operation_preview_is_selected")
	core.PuregoSafeRegister(&XGtkPrintOperationPreviewRenderPage, lib, "gtk_print_operation_preview_render_page")

}
