// Package gtk was automatically generated by github.com/jwijenbergh/puregotk DO NOT EDIT
package gtk

import (
	"unsafe"

	"github.com/jwijenbergh/purego"
	"github.com/jwijenbergh/puregotk/internal/core"
	"github.com/jwijenbergh/puregotk/v4/gobject"
)

type ShortcutLabelClass struct {
}

func (x *ShortcutLabelClass) GoPointer() uintptr {
	return uintptr(unsafe.Pointer(x))
}

// `GtkShortcutLabel` displays a single keyboard shortcut or gesture.
//
// The main use case for `GtkShortcutLabel` is inside a [class@Gtk.ShortcutsWindow].
type ShortcutLabel struct {
	Widget
}

func ShortcutLabelNewFromInternalPtr(ptr uintptr) *ShortcutLabel {
	cls := &ShortcutLabel{}
	cls.Ptr = ptr
	return cls
}

var xNewShortcutLabel func(string) uintptr

// Creates a new `GtkShortcutLabel` with @accelerator set.
func NewShortcutLabel(AcceleratorVar string) *ShortcutLabel {
	var cls *ShortcutLabel

	cret := xNewShortcutLabel(AcceleratorVar)

	if cret == 0 {
		return nil
	}
	gobject.IncreaseRef(cret)
	cls = &ShortcutLabel{}
	cls.Ptr = cret
	return cls
}

var xShortcutLabelGetAccelerator func(uintptr) string

// Retrieves the current accelerator of @self.
func (x *ShortcutLabel) GetAccelerator() string {

	cret := xShortcutLabelGetAccelerator(x.GoPointer())
	return cret
}

var xShortcutLabelGetDisabledText func(uintptr) string

// Retrieves the text that is displayed when no accelerator is set.
func (x *ShortcutLabel) GetDisabledText() string {

	cret := xShortcutLabelGetDisabledText(x.GoPointer())
	return cret
}

var xShortcutLabelSetAccelerator func(uintptr, string)

// Sets the accelerator to be displayed by @self.
func (x *ShortcutLabel) SetAccelerator(AcceleratorVar string) {

	xShortcutLabelSetAccelerator(x.GoPointer(), AcceleratorVar)

}

var xShortcutLabelSetDisabledText func(uintptr, string)

// Sets the text to be displayed by @self when no accelerator is set.
func (x *ShortcutLabel) SetDisabledText(DisabledTextVar string) {

	xShortcutLabelSetDisabledText(x.GoPointer(), DisabledTextVar)

}

func (c *ShortcutLabel) GoPointer() uintptr {
	return c.Ptr
}

func (c *ShortcutLabel) SetGoPointer(ptr uintptr) {
	c.Ptr = ptr
}

// Retrieves the `GtkAccessibleRole` for the given `GtkAccessible`.
func (x *ShortcutLabel) GetAccessibleRole() AccessibleRole {

	cret := XGtkAccessibleGetAccessibleRole(x.GoPointer())
	return cret
}

// Resets the accessible @property to its default value.
func (x *ShortcutLabel) ResetProperty(PropertyVar AccessibleProperty) {

	XGtkAccessibleResetProperty(x.GoPointer(), PropertyVar)

}

// Resets the accessible @relation to its default value.
func (x *ShortcutLabel) ResetRelation(RelationVar AccessibleRelation) {

	XGtkAccessibleResetRelation(x.GoPointer(), RelationVar)

}

// Resets the accessible @state to its default value.
func (x *ShortcutLabel) ResetState(StateVar AccessibleState) {

	XGtkAccessibleResetState(x.GoPointer(), StateVar)

}

// Updates a list of accessible properties.
//
// See the [enum@Gtk.AccessibleProperty] documentation for the
// value types of accessible properties.
//
// This function should be called by `GtkWidget` types whenever
// an accessible property change must be communicated to assistive
// technologies.
//
// Example:
// ```c
// value = gtk_adjustment_get_value (adjustment);
// gtk_accessible_update_property (GTK_ACCESSIBLE (spin_button),
//
//	GTK_ACCESSIBLE_PROPERTY_VALUE_NOW, value,
//	-1);
//
// ```
func (x *ShortcutLabel) UpdateProperty(FirstPropertyVar AccessibleProperty, varArgs ...interface{}) {

	XGtkAccessibleUpdateProperty(x.GoPointer(), FirstPropertyVar, varArgs...)

}

// Updates an array of accessible properties.
//
// This function should be called by `GtkWidget` types whenever an accessible
// property change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *ShortcutLabel) UpdatePropertyValue(NPropertiesVar int, PropertiesVar uintptr, ValuesVar uintptr) {

	XGtkAccessibleUpdatePropertyValue(x.GoPointer(), NPropertiesVar, PropertiesVar, ValuesVar)

}

// Updates a list of accessible relations.
//
// This function should be called by `GtkWidget` types whenever an accessible
// relation change must be communicated to assistive technologies.
//
// If the [enum@Gtk.AccessibleRelation] requires a list of references,
// you should pass each reference individually, followed by %NULL, e.g.
//
// ```c
// gtk_accessible_update_relation (accessible,
//
//	GTK_ACCESSIBLE_RELATION_CONTROLS,
//	  ref1, NULL,
//	GTK_ACCESSIBLE_RELATION_LABELLED_BY,
//	  ref1, ref2, ref3, NULL,
//	-1);
//
// ```
func (x *ShortcutLabel) UpdateRelation(FirstRelationVar AccessibleRelation, varArgs ...interface{}) {

	XGtkAccessibleUpdateRelation(x.GoPointer(), FirstRelationVar, varArgs...)

}

// Updates an array of accessible relations.
//
// This function should be called by `GtkWidget` types whenever an accessible
// relation change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *ShortcutLabel) UpdateRelationValue(NRelationsVar int, RelationsVar uintptr, ValuesVar uintptr) {

	XGtkAccessibleUpdateRelationValue(x.GoPointer(), NRelationsVar, RelationsVar, ValuesVar)

}

// Updates a list of accessible states. See the [enum@Gtk.AccessibleState]
// documentation for the value types of accessible states.
//
// This function should be called by `GtkWidget` types whenever an accessible
// state change must be communicated to assistive technologies.
//
// Example:
// ```c
// value = GTK_ACCESSIBLE_TRISTATE_MIXED;
// gtk_accessible_update_state (GTK_ACCESSIBLE (check_button),
//
//	GTK_ACCESSIBLE_STATE_CHECKED, value,
//	-1);
//
// ```
func (x *ShortcutLabel) UpdateState(FirstStateVar AccessibleState, varArgs ...interface{}) {

	XGtkAccessibleUpdateState(x.GoPointer(), FirstStateVar, varArgs...)

}

// Updates an array of accessible states.
//
// This function should be called by `GtkWidget` types whenever an accessible
// state change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *ShortcutLabel) UpdateStateValue(NStatesVar int, StatesVar uintptr, ValuesVar uintptr) {

	XGtkAccessibleUpdateStateValue(x.GoPointer(), NStatesVar, StatesVar, ValuesVar)

}

// Gets the ID of the @buildable object.
//
// `GtkBuilder` sets the name based on the ID attribute
// of the &lt;object&gt; tag used to construct the @buildable.
func (x *ShortcutLabel) GetBuildableId() string {

	cret := XGtkBuildableGetBuildableId(x.GoPointer())
	return cret
}

func init() {
	lib, err := purego.Dlopen(core.GetPath("GTK"), purego.RTLD_NOW|purego.RTLD_GLOBAL)
	if err != nil {
		panic(err)
	}

	core.PuregoSafeRegister(&xNewShortcutLabel, lib, "gtk_shortcut_label_new")

	core.PuregoSafeRegister(&xShortcutLabelGetAccelerator, lib, "gtk_shortcut_label_get_accelerator")
	core.PuregoSafeRegister(&xShortcutLabelGetDisabledText, lib, "gtk_shortcut_label_get_disabled_text")
	core.PuregoSafeRegister(&xShortcutLabelSetAccelerator, lib, "gtk_shortcut_label_set_accelerator")
	core.PuregoSafeRegister(&xShortcutLabelSetDisabledText, lib, "gtk_shortcut_label_set_disabled_text")

}
