// Package gtk was automatically generated by github.com/jwijenbergh/puregotk DO NOT EDIT
package gtk

import "unsafe"

type ShortcutsShortcutClass struct {
}

func (x *ShortcutsShortcutClass) GoPointer() uintptr {
	return uintptr(unsafe.Pointer(x))
}

// GtkShortcutType specifies the kind of shortcut that is being described.
//
// More values may be added to this enumeration over time.
type ShortcutType int

const (

	// The shortcut is a keyboard accelerator. The GtkShortcutsShortcut:accelerator
	//   property will be used.
	ShortcutAcceleratorValue ShortcutType = 0
	// The shortcut is a pinch gesture. GTK provides an icon and subtitle.
	ShortcutGesturePinchValue ShortcutType = 1
	// The shortcut is a stretch gesture. GTK provides an icon and subtitle.
	ShortcutGestureStretchValue ShortcutType = 2
	// The shortcut is a clockwise rotation gesture. GTK provides an icon and subtitle.
	ShortcutGestureRotateClockwiseValue ShortcutType = 3
	// The shortcut is a counterclockwise rotation gesture. GTK provides an icon and subtitle.
	ShortcutGestureRotateCounterclockwiseValue ShortcutType = 4
	// The shortcut is a two-finger swipe gesture. GTK provides an icon and subtitle.
	ShortcutGestureTwoFingerSwipeLeftValue ShortcutType = 5
	// The shortcut is a two-finger swipe gesture. GTK provides an icon and subtitle.
	ShortcutGestureTwoFingerSwipeRightValue ShortcutType = 6
	// The shortcut is a gesture. The GtkShortcutsShortcut:icon property will be
	//   used.
	ShortcutGestureValue ShortcutType = 7
	// The shortcut is a swipe gesture. GTK provides an icon and subtitle.
	ShortcutGestureSwipeLeftValue ShortcutType = 8
	// The shortcut is a swipe gesture. GTK provides an icon and subtitle.
	ShortcutGestureSwipeRightValue ShortcutType = 9
)

// A `GtkShortcutsShortcut` represents a single keyboard shortcut or gesture
// with a short text.
//
// This widget is only meant to be used with `GtkShortcutsWindow`.
type ShortcutsShortcut struct {
	Widget
}

func ShortcutsShortcutNewFromInternalPtr(ptr uintptr) *ShortcutsShortcut {
	cls := &ShortcutsShortcut{}
	cls.Ptr = ptr
	return cls
}

func (c *ShortcutsShortcut) GoPointer() uintptr {
	return c.Ptr
}

func (c *ShortcutsShortcut) SetGoPointer(ptr uintptr) {
	c.Ptr = ptr
}

// Retrieves the `GtkAccessibleRole` for the given `GtkAccessible`.
func (x *ShortcutsShortcut) GetAccessibleRole() AccessibleRole {

	cret := XGtkAccessibleGetAccessibleRole(x.GoPointer())
	return cret
}

// Resets the accessible @property to its default value.
func (x *ShortcutsShortcut) ResetProperty(PropertyVar AccessibleProperty) {

	XGtkAccessibleResetProperty(x.GoPointer(), PropertyVar)

}

// Resets the accessible @relation to its default value.
func (x *ShortcutsShortcut) ResetRelation(RelationVar AccessibleRelation) {

	XGtkAccessibleResetRelation(x.GoPointer(), RelationVar)

}

// Resets the accessible @state to its default value.
func (x *ShortcutsShortcut) ResetState(StateVar AccessibleState) {

	XGtkAccessibleResetState(x.GoPointer(), StateVar)

}

// Updates a list of accessible properties.
//
// See the [enum@Gtk.AccessibleProperty] documentation for the
// value types of accessible properties.
//
// This function should be called by `GtkWidget` types whenever
// an accessible property change must be communicated to assistive
// technologies.
//
// Example:
// ```c
// value = gtk_adjustment_get_value (adjustment);
// gtk_accessible_update_property (GTK_ACCESSIBLE (spin_button),
//
//	GTK_ACCESSIBLE_PROPERTY_VALUE_NOW, value,
//	-1);
//
// ```
func (x *ShortcutsShortcut) UpdateProperty(FirstPropertyVar AccessibleProperty, varArgs ...interface{}) {

	XGtkAccessibleUpdateProperty(x.GoPointer(), FirstPropertyVar, varArgs...)

}

// Updates an array of accessible properties.
//
// This function should be called by `GtkWidget` types whenever an accessible
// property change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *ShortcutsShortcut) UpdatePropertyValue(NPropertiesVar int, PropertiesVar uintptr, ValuesVar uintptr) {

	XGtkAccessibleUpdatePropertyValue(x.GoPointer(), NPropertiesVar, PropertiesVar, ValuesVar)

}

// Updates a list of accessible relations.
//
// This function should be called by `GtkWidget` types whenever an accessible
// relation change must be communicated to assistive technologies.
//
// If the [enum@Gtk.AccessibleRelation] requires a list of references,
// you should pass each reference individually, followed by %NULL, e.g.
//
// ```c
// gtk_accessible_update_relation (accessible,
//
//	GTK_ACCESSIBLE_RELATION_CONTROLS,
//	  ref1, NULL,
//	GTK_ACCESSIBLE_RELATION_LABELLED_BY,
//	  ref1, ref2, ref3, NULL,
//	-1);
//
// ```
func (x *ShortcutsShortcut) UpdateRelation(FirstRelationVar AccessibleRelation, varArgs ...interface{}) {

	XGtkAccessibleUpdateRelation(x.GoPointer(), FirstRelationVar, varArgs...)

}

// Updates an array of accessible relations.
//
// This function should be called by `GtkWidget` types whenever an accessible
// relation change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *ShortcutsShortcut) UpdateRelationValue(NRelationsVar int, RelationsVar uintptr, ValuesVar uintptr) {

	XGtkAccessibleUpdateRelationValue(x.GoPointer(), NRelationsVar, RelationsVar, ValuesVar)

}

// Updates a list of accessible states. See the [enum@Gtk.AccessibleState]
// documentation for the value types of accessible states.
//
// This function should be called by `GtkWidget` types whenever an accessible
// state change must be communicated to assistive technologies.
//
// Example:
// ```c
// value = GTK_ACCESSIBLE_TRISTATE_MIXED;
// gtk_accessible_update_state (GTK_ACCESSIBLE (check_button),
//
//	GTK_ACCESSIBLE_STATE_CHECKED, value,
//	-1);
//
// ```
func (x *ShortcutsShortcut) UpdateState(FirstStateVar AccessibleState, varArgs ...interface{}) {

	XGtkAccessibleUpdateState(x.GoPointer(), FirstStateVar, varArgs...)

}

// Updates an array of accessible states.
//
// This function should be called by `GtkWidget` types whenever an accessible
// state change must be communicated to assistive technologies.
//
// This function is meant to be used by language bindings.
func (x *ShortcutsShortcut) UpdateStateValue(NStatesVar int, StatesVar uintptr, ValuesVar uintptr) {

	XGtkAccessibleUpdateStateValue(x.GoPointer(), NStatesVar, StatesVar, ValuesVar)

}

// Gets the ID of the @buildable object.
//
// `GtkBuilder` sets the name based on the ID attribute
// of the &lt;object&gt; tag used to construct the @buildable.
func (x *ShortcutsShortcut) GetBuildableId() string {

	cret := XGtkBuildableGetBuildableId(x.GoPointer())
	return cret
}
