// Package pango was automatically generated by github.com/jwijenbergh/puregotk DO NOT EDIT
package pango

// `PangoDirection` represents a direction in the Unicode bidirectional
// algorithm.
//
// Not every value in this enumeration makes sense for every usage of
// `PangoDirection`; for example, the return value of [func@unichar_direction]
// and [func@find_base_dir] cannot be `PANGO_DIRECTION_WEAK_LTR` or
// `PANGO_DIRECTION_WEAK_RTL`, since every character is either neutral
// or has a strong direction; on the other hand `PANGO_DIRECTION_NEUTRAL`
// doesn't make sense to pass to [func@itemize_with_base_dir].
//
// The `PANGO_DIRECTION_TTB_LTR`, `PANGO_DIRECTION_TTB_RTL` values come from
// an earlier interpretation of this enumeration as the writing direction
// of a block of text and are no longer used. See `PangoGravity` for how
// vertical text is handled in Pango.
//
// If you are interested in text direction, you should really use fribidi
// directly. `PangoDirection` is only retained because it is used in some
// public apis.
type Direction int

const (

	// A strong left-to-right direction
	DirectionLtrValue Direction = 0
	// A strong right-to-left direction
	DirectionRtlValue Direction = 1
	// Deprecated value; treated the
	//   same as `PANGO_DIRECTION_RTL`.
	DirectionTtbLtrValue Direction = 2
	// Deprecated value; treated the
	//   same as `PANGO_DIRECTION_LTR`
	DirectionTtbRtlValue Direction = 3
	// A weak left-to-right direction
	DirectionWeakLtrValue Direction = 4
	// A weak right-to-left direction
	DirectionWeakRtlValue Direction = 5
	// No direction specified
	DirectionNeutralValue Direction = 6
)
